<?php
// Include the PHPWord.php, all other classes were loaded by an autoloader
require_once '../classes/PHPWord.php';

function convert_smart_quotes($string) 
{ 
    $search = array(chr(145), 
                    chr(146), 
                    chr(147), 
                    chr(148), 
                    chr(151)); 

    $replace = array("'", 
                     "'", 
                     '"', 
                     '"', 
                     '-'); 

    return str_replace($search, $replace, $string); 
}

// Create a new PHPWord Object
$PHPWord = new PHPWord();

$PHPWord->setDefaultFontName('Arial');
$PHPWord->setDefaultFontSize(11);



require_once('../inc/connect.php');
require_once('../inc/util.php');
require_once('../inc/config.php');

$estat_expedient = array(0 => 'per assignar', 1 => 'obert', 2 => 'tancat');
$label_expedient = array(0 => 'label-danger', 1 => 'label-info', 2 => 'label-success');

$whos = select('informacio_who');
$document_types = select('informacio_document_type');
$channels = select('informacio_channel');
$provenances = select('informacio_provenance');
$users = select('app_users');
$organitzacions = select('informacio_org');
$temes = select('informacio_temes');
$subtemes = select('informacio_temes_altres');
$knows = select('informacio_know');
$froms = select('informacio_derived_from');
$tos = select('informacio_derived_to');
$districtes = select('app_districtes');
$barris = select('app_barris');
$countries = select_sql("SELECT * FROM app_country ORDER BY name");
$quins = select('expedient_qui_discrimina');
$tipus_actuacions = select('expedients_actuacions_type');
$discriminacions = select('expedient_discriminacions');
$blocs = select('expedient_discriminacions_blocs');
$drets = select('expedient_drets');

if (isset($_GET['id'])) {
    $sql = "SELECT * FROM expedients
                WHERE expedients.idi = ".$_GET['id'];
    $noticies = select_sql($sql);

    $registre = ($noticies[0]);
    $registre = array_map("stripslashes", $registre);
    $registre = array_map("utf8_encode", $registre);
    
    $sql = "SELECT * FROM informacio
                WHERE informacio.id = ".$registre['idi'];
    $informacions = select_sql($sql);

    $informacio = ($informacions[0]);
    $informacio = array_map("stripslashes", $informacio);
    $informacio = array_map("utf8_encode", $informacio);

$sql = "SELECT expedients_actuacions.* FROM expedients_actuacions WHERE expedients_actuacions.idE = ".$registre['id'];
$actuacions = select_sql($sql);

$sql = "SELECT expedients_tancament.* FROM expedients_tancament WHERE expedients_tancament.ide = ".$registre['id'];
$tancats = select_sql($sql);
$tancat = $tancats[0];

$actuacions_types = select('expedients_actuacions_type');
$tancaments = select('expedient_tancament');
$tancaments_derivacions = select('expedient_tancament_derivacio');
$tancaments_no = select('expedient_tancament_no');

$now = date('d-m-Y H:i:s');
 
}

$section = $PHPWord->createSection();
$header = $section->createHeader(array('marginLeft' => 700));
$imageStyle = array('width'=>300, 'height'=>69);
$header->addImage("../img/header.jpg", $imageStyle);
$header->addTextBreak();

$section->addText("Informe", array('name'=>'Arial', 'size'=>22, 'bold'=>true), array('align' => 'center'));
$section->addTextBreak();
$section->addText(utf8_decode("EXPEDIENT ").$registre['ide'], array('name'=>'Arial', 'size'=>12, 'bold'=>true));
$section->addTextBreak();
$section->addText(utf8_decode("Referent:").$users[$registre['referent']-1]['name'], array('name'=>'Arial', 'size'=>12, 'bold'=>true));
$section->addTextBreak();
$section->addText(utf8_decode("Dades personals"), array('name'=>'Arial', 'size'=>14, 'bold'=>true, 'underline' => PHPWord_Style_Font::UNDERLINE_SINGLE));
$section->addText(utf8_decode($informacio['name']." ".$informacio['surname_1']." ".$informacio['surname_2']." ".$informacio['alias']), array('name'=>'Arial', 'size'=>12));
$section->addTextBreak();

$section->addText(utf8_decode("Discriminació"), array('name'=>'Arial', 'size'=>14, 'bold'=>true, 'underline' => PHPWord_Style_Font::UNDERLINE_SINGLE));
$section->addText(utf8_decode("Motius de la discriminació"), array('name'=>'Arial', 'size'=>13, 'bold'=>true));
if ($registre['motius'] != '') {   
    $elements = unserialize($registre['motius']);
    $text = "";
		foreach ($elements as $element) { 
			
			$text .= $discriminacions[$element-1]['literal'].", ";
}
$text = substr($text, 0, -2);
$section->addText(($text), array('name'=>'Arial', 'size'=>12));
}
$section->addTextBreak();
$section->addText(utf8_decode("Discriminació"), array('name'=>'Arial', 'size'=>13, 'bold'=>true));
if ($registre['motius'] != '') {  
	$contador = array();  
	$elements = unserialize($registre['motius']);
	$text = "";
	foreach ($elements as $element) {
		if(!in_array($blocs[$discriminacions[$element-1]['bloc'] - 1], $contador)) { 
			array_push ($contador, $blocs[$discriminacions[$element-1]['bloc'] - 1]);
			$text .= $blocs[$discriminacions[$element-1]['bloc'] - 1]['literal'].", ";
				
 }

 }
 $text = substr($text, 0, -2); 
 $section->addText(($text), array('name'=>'Arial', 'size'=>12));
 }
$section->addTextBreak();
$section->addText(utf8_decode("Drets vulnerats"), array('name'=>'Arial', 'size'=>13, 'bold'=>true));
if ($registre['drets'] != '') { 
	$text = "";
	$elements = unserialize($registre['drets']);
		foreach ($elements as $element) { 
			$text .= $drets[$element-1]['literal'].", ";
			
 }
 $text = substr($text, 0, -2); 
 $section->addText(($text), array('name'=>'Arial', 'size'=>12));
 }								
$section->addTextBreak();
$section->addText(utf8_decode("Descripció"), array('name'=>'Arial', 'size'=>13, 'bold'=>true));
$section->addText(utf8_decode($registre['descripcio']), array('name'=>'Arial', 'size'=>12));

$section->addTextBreak();
$section->addText(utf8_decode("Quan s'ha produït la discriminació"), array('name'=>'Arial', 'size'=>13, 'bold'=>true));
$section->addText($registre['quan'], array('name'=>'Arial', 'size'=>12));

$section->addTextBreak();
$section->addText(utf8_decode("Part acusada"), array('name'=>'Arial', 'size'=>14, 'bold'=>true, 'underline' => PHPWord_Style_Font::UNDERLINE_SINGLE));
$section->addText(utf8_decode($registre['acusada']), array('name'=>'Arial', 'size'=>12));

$section->addText(utf8_decode($registre['acusada_lloc']), array('name'=>'Arial', 'size'=>12));
$section->addTextBreak();
$section->addText(utf8_decode("Altres agents"), array('name'=>'Arial', 'size'=>14, 'bold'=>true, 'underline' => PHPWord_Style_Font::UNDERLINE_SINGLE));
foreach ($actuacions as $actuacio) {
	if ($actuacio['tipus'] == 10) {
		$section->addText($actuacio['tercera_nom'], array('name'=>'Arial', 'size'=>12));
		$section->addTextBreak();
	}
}

$section->addText(utf8_decode("Actuacions efectuades"), array('name'=>'Arial', 'size'=>14, 'bold'=>true, 'underline' => PHPWord_Style_Font::UNDERLINE_SINGLE));
foreach ($actuacions as $actuacio) {
	if ($actuacio['tipus'] != 10) {
		
		$data0 = DateTime::createFromFormat('Y-m-d H:i:s', $actuacio['time']);
		$data = $data0->format('d-m-Y H:i:s');
		if ($actuacio['tipus'] != 11 && $actuacio['tipus'] != 12) {
		$section->addText($data." - ".$actuacions_types[$actuacio['tipus']-1]['literal'], array('name'=>'Arial', 'size'=>12, 'bold'=>true));
		}
		if ($actuacio['tipus'] == 11) {
	      	$section->addText($data." - Reobertura de l'expedient", array('name'=>'Arial', 'size'=>12, 'bold'=>true));
	      				 }
	    if ($actuacio['tipus'] == 12) {
	      	$section->addText($data." - Tancament de l'expedient", array('name'=>'Arial', 'size'=>12, 'bold'=>true));
	     }	
		$section->addText($actuacio['descripcio'], array('name'=>'Arial', 'size'=>12));
		$section->addTextBreak();
	}
}

if ($registre['estat'] == 2) {
$section->addText(utf8_decode("Tancament expedient"), array('name'=>'Arial', 'size'=>14, 'bold'=>true));
$section->addText($tancaments[$tancat['tipus']-1]['literal'], array('name'=>'Arial', 'size'=>12));
$section->addText($tancaments_derivacions[$tancat['derivacio_rao']-1]['literal'], array('name'=>'Arial', 'size'=>12));
$section->addText($tancat['observacions'], array('name'=>'Arial', 'size'=>12));
}
$section->addTextBreak(2);
$section->addText(utf8_decode("Signat"), array('name'=>'Arial', 'size'=>12, 'bold'=>true));
$section->addTextBreak(4);
$section->addText(utf8_decode("Barcelona, a "), array('name'=>'Arial', 'size'=>12, 'bold'=>true));

$filename = "Informe.".time().".docx";
header('Content-Type: application/vnd.ms-word');
header('Content-Disposition: attachment;filename='.$filename);
header('Cache-Control: max-age=0');
 $writer=PHPWord_IOFactory::createWriter($PHPWord,"Word2007");
 $writer->save("php://output");
?>